#include <iostream>
#include <vector>
using namespace std;

int main()
{

    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    double max_count=0;
    size_t height = 0;

    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);

    for (size_t i=0; i<number_count; i++)
    {
        cerr <<"Enter number: ";
        cin >> numbers[i];
    }
    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<size_t> bins(bin_count);

    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
                if (bins[j]>max_count)
                {
                    max_count=bins[j];
                }
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
            if (bins[bin_count - 1]>max_count)
            {
                max_count=bins[bin_count - 1];
            }
        }
    }
    for (size_t j = 0; j < bin_count; j++)
    {
        if (max_count<=MAX_ASTERISK)
        {
            height=bins[j];
        }
        else
        {
            height = static_cast<size_t>(MAX_ASTERISK * static_cast<double>(bins[j]) / max_count);
        }

        if (bins[j]<100 && bins[j]>=10)
        {
            cout<< " " << bins[j] << "|" << string(height, '*') << endl;
        }
        if (bins[j]<10)
        {
            cout<< "  " << bins[j] << "|" << string(height, '*') << endl;
        }
        if (bins[j]>=100)
        {
            cout<< "" << bins[j] << "|" << string(height, '*') << endl;
        }
    }
    return 0;
}
